clear
%%
%load invfluss;
%load energie;
load invfluss1;
load energie1;
invfluss = invfluss1;
energie = energie1;



%%
%invfluss = invfluss(1:10000).'; % only take a small section
%energie = energie(1:10000).'; % only take a small section
plot(invfluss,energie,'.','MarkerSize',1);
%%
a0 = 40e-9; % lattice period
K = 2*pi/a0;  % rec lattice vektor
h = 6.62607015e-34;
hbar = h/(2*pi);
e = 1.602176634e-19; 
vF = 1e6; % Fermi velocity in graphene
B1 = h/(e*a0^2);  % Field corresponding to one flux qt per unit cell

nmax = 11; % max # of LL to plot
V0 = 0.02*e; % use 10 meV (arbitrary value)

%B = 0.001:0.001:10; % Tesla
butterflies = 300;
B=double.empty;
en=double.empty;
for i =0:butterflies
    datalen = round(length(invfluss)/(i+1)); % use fewer points for low B field values...
    %datalen = round(length(invfluss)/(i+200)); % use fewer points for low B field values...
%
    %datalen =length(invfluss); % don't use adaptive size for optimzed array!
B(length(B)+1:length(B)+datalen) = 1./((invfluss(1:datalen) + i)/h*e*a0^2); % let's take some unproblematic B field range first
en(length(en)+1:length(en)+datalen) = energie(1:datalen); 
end
% Maybe we can put some adaptive scaling here. So, that for higher
% butterflies the number of data points is reduced, as they will only
% occupy very little space on the B axis... ... done, see above.


%energie = en;
%clear en;

%%

EDmat = B; % dummy assignment
%Emodmin = B;
%Emodplus = B; % also dummy assignments
EHofst = B; %dummy assignment

l = sqrt(abs(hbar./(e*B))); % take absolute value of B to be sure
u = K^2*l.^2/2;
fb_mat = -1*ones(nmax+1); % flat band positions and energies for each Landau level
fben_mat = zeros(nmax+1); % initialize to -1,0, so that empty points don't appear in the plot

B_lines=0:0.001:8; % for plotting some relations
l_lines = sqrt(abs(hbar./(e*B_lines)));
ED_lines_mat = double.empty;  % initialize array
Efb_lines_mat = double.empty; % this is for semiclassical flat band condition

lambdamax = 5;  % max fb condition

for lambda = 1:lambdamax
Efb_lines_mat(lambda,:)=vF*e*B_lines*a0/2*(lambda-0.25); % apparently, the energy is linear in Rc.... for graphene
end



for n =0:1:nmax %% LL index


EDn = vF*hbar./l * sqrt(2*n); %
EDmat(n+1,:) = EDn;
ED_lines = vF*hbar./l_lines * sqrt(2*n); %
ED_lines_mat(n+1,:) = ED_lines;



bw = V0/2*exp(-u/2).*(Laguerre(n,u) + Laguerre(n-1,u)); % Laguerre Poly for n = -1 set to 0
%Emodmin(n+1,:) = EDn - bw;
%Emodplus(n+1,:) = EDn + bw;
EHofst(n+1,:) = EDn + 0.5*en.*bw;

% And now find all the flat band positions...
fb = K^2/2*hbar./(e*roots(LaguerrePoly(n) + [0 LaguerrePoly(n-1)]));
% should be the magnetic fields
l_fb = sqrt(abs(hbar./(e*fb))); % corresponding magnetic lengths
ED_fb = vF*hbar./l_fb * sqrt(2*n); % and Landau level energy here
fb_mat(n+1,1:n) = fb; % for some reason this works for n=0...
fben_mat(n+1,1:n) = ED_fb;
end
%%
plot(B,EDmat,'.','MarkerSize',1);
%%
plot(B/B1,EHofst/e,'.','MarkerSize',1,'Color','black');
xlim([0 3]);
ylim([0 0.2]);

%%
% Figure for paper 

clf
ax1 = axes('position',[0.1 0.13 0.6 0.85],'box','on'); % large plot (a)
ax2 = axes('position',[0.75 0.13 0.2 0.48],'box','on'); % Zoom (c)
ax3 = axes('position',[0.75 0.67 0.2 0.3],'box','on'); % Hofstadter only (b)
axes(ax1);
hold on
%plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',12,'MarkerFaceColor','yellow','MarkerEdgeColor','yellow');


plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',12,'MarkerFaceColor',[1 0.62 0.07],'MarkerEdgeColor','yellow');


%colors = transpose([linspace(0.2,0.1,12);linspace(0.8,0.6,12);linspace(0.4,0.2,12)]);
%colors = transpose([linspace(0.7,0.1,12);linspace(0.7,0.1,12);linspace(0.7,0.1,12)]);
%colors = transpose([linspace(0.20,0.22,12);linspace(0.36,0.5,12);linspace(0.63,0.34,12)]);
colors = transpose([linspace(0.10,0.1,12);linspace(0.4,0.4,12);linspace(0.3,0.3,12)]);

set(ax1,'ColorOrder',colors);
ax1.ColorOrderIndex = 1;

%plot(B/B1,EHofst/e,'.','MarkerSize',3);
% remove for test

%plot(B/B1,EHofst/e,'.','MarkerSize',3,'Color',[0.38 0.38 0.38]);


%plot(B_lines/B1,ED_lines_mat/e,'Color','green','LineWidth',1);
%plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',15,'Color','red');
%plot([0 3],[0.116 0.116],'--','Color',[0.49 0.18 0.55],'LineWidth',2);
plot([0 3],[0.116 0.116],'--','Color',[0.62 0.28 0.055],'LineWidth',2);
%plot(B_lines/B1,Efb_lines_mat/e,'Color','magenta');

text(0.07,0.127,'E_F','FontSize',24,'Color',[0.62 0.28 0.055]);
%x1 = 0.3 ;  % Section of Data to be zoomed into in inset
%x2 = 0.52; % Those are the values for a nice looking plot
%y1 = 0.08;
%y2 = 0.11;
x1 = 0.18 ;  % Section of Data to be zoomed into in inset
x2 = 0.35;  % Here we try different sections of the data
y1 = 0.05;
y2 = 0.085;
text(0.1,0.21,'a','FontWeight','bold','FontSize',30,'Color','black');




%rectangle('Position',[x1 y1 x2-x1 y2-y1],'EdgeColor',[0.0 0.8 0.0],'LineWidth',1);
%rectangle('Position',[x1 y1 x2-x1
%y2-y1],'EdgeColor','blue','LineWidth',1);  % from Version May 2021
rectangle('Position',[x1 y1 x2-x1 y2-y1],'EdgeColor','blue','LineWidth',2);
%rectangle('Position',[x1 y1 x2-x1 y2-y1],'EdgeColor',[0.5 0.5 1],'LineWidth',2);

hold off
xlim([0 3]);
ylim([-0.005 0.226]);
xlabel('\Phi/\Phi_0');
ylabel('E (eV)');
ax1.FontSize = 20;
ax1.LineWidth = 1.5;

axes(ax2);
%plot(B/B1,EHofst/e,'.','MarkerSize',2,'Color',[0.38 0.38 0.38]);
plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',12,'MarkerFaceColor',[1 0.62 0.07],'MarkerEdgeColor','yellow');

hold on
%plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',15,'Color','red','LineWidth',1.5);
%plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',13,'Color','red');

%colors = transpose([linspace(0.22,0.20,12);linspace(0.5,0.36,12);linspace(0.34,0.63,12)]);
colors = transpose([linspace(0.10,0.1,12);linspace(0.4,0.4,12);linspace(0.3,0.3,12)]);

%colors = [0.8 0.8 0.8; 0.7 0.7 0.7; 0.6 0.6 0.6; 0.5 0.5 0.5];
set(ax2,'ColorOrder',colors);
ax2.ColorOrderIndex = 1;

%plot(B/B1,EHofst/e,'.','MarkerSize',2);
% remove for test


%plot(B_lines/B1,Efb_lines_mat/e,'Color','magenta');

hold off
xlim([x1 x2]);
ylim([y1 y2]);
%xlabel('\Phi/\Phi_0');
%ylabel('E (eV)');
ax2.FontSize = 16;
ax2.LineWidth = 1.2;
yticks([0.05:0.01:0.08]);
text(0.31,0.045,'\Phi/\Phi_0','FontSize',16)
text(0.16,0.072,'E (eV)','Rotation',90,'FontSize',16)

text(0.32, 0.053,'c','FontWeight','bold','FontSize',30);



axes(ax3)
%plot(invfluss,energie/2,'.','MarkerSize',1);
% remove for test

xlim([0 1]);
ylim([-1 1]);

ax3.FontSize = 16;
ax3.LineWidth = 1.2;
%xlabel('\Phi_0/\Phi');
yticks([-1 0 1]);
text(0.75, -1.18,'\Phi_0/\Phi','FontSize',16);
text(-0.13,0,'\Delta\epsilon_\alpha','Rotation',90,'FontSize',16)

text(0.8, 0.71,'b','FontWeight','bold','FontSize',30,'BackgroundColor','white');





%%
% Figure for paper 

clf
ax1 = axes('position',[0.1 0.13 0.6 0.85],'box','off'); % large plot (a)
ax2 = axes('position',[0.75 0.13 0.2 0.48],'box','off'); % Zoom (c)
ax3 = axes('position',[0.75 0.67 0.2 0.3],'box','off'); % Hofstadter only (b)
axes(ax1);
hold on

%plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',12,'MarkerFaceColor',[1 0.62 0.07],'MarkerEdgeColor','yellow');


%colors = transpose([linspace(0.10,0.1,12);linspace(0.4,0.4,12);linspace(0.3,0.3,12)]);

set(ax1,'ColorOrder',colors);
ax1.ColorOrderIndex = 1;

axis off
plot(B/B1,EHofst/e,'.','MarkerSize',3);
% remove for test

%plot([0 3],[0.116 0.116],'--','Color',[0.62 0.28 0.055],'LineWidth',2);

%text(0.07,0.127,'E_F','FontSize',24,'Color',[0.62 0.28 0.055]);
x1 = 0.18 ;  % Section of Data to be zoomed into in inset
x2 = 0.35;  % Here we try different sections of the data
y1 = 0.05;
y2 = 0.085;
%text(0.1,0.21,'a','FontWeight','bold','FontSize',30,'Color','black');



%rectangle('Position',[x1 y1 x2-x1 y2-y1],'EdgeColor','blue','LineWidth',2);

hold off
xlim([0 3]);
ylim([-0.005 0.226]);
%xlabel('\Phi/\Phi_0');
%ylabel('E (eV)');
%ax1.FontSize = 20;
%ax1.LineWidth = 1.5;

axes(ax2);
axis off

%plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',12,'MarkerFaceColor',[1 0.62 0.07],'MarkerEdgeColor','yellow');

hold on
colors = transpose([linspace(0.10,0.1,12);linspace(0.4,0.4,12);linspace(0.3,0.3,12)]);

set(ax2,'ColorOrder',colors);
ax2.ColorOrderIndex = 1;

plot(B/B1,EHofst/e,'.','MarkerSize',2);
% remove for test



hold off
xlim([x1 x2]);
ylim([y1 y2]);
ax2.FontSize = 16;
ax2.LineWidth = 1.2;
yticks([0.05:0.01:0.08]);
%text(0.31,0.045,'\Phi/\Phi_0','FontSize',16)
%text(0.16,0.072,'E (eV)','Rotation',90,'FontSize',16)

%text(0.32, 0.053,'c','FontWeight','bold','FontSize',30);



axes(ax3)

plot(invfluss,energie/2,'.','MarkerSize',1);
axis off
% remove for test


ax3.FontSize = 16;
ax3.LineWidth = 1.2;
%yticks([-1 0 1]);
%text(0.75, -1.18,'\Phi_0/\Phi','FontSize',16);
%text(-0.13,0,'\Delta\epsilon_\alpha','Rotation',90,'FontSize',16)

%text(0.8, 0.71,'b','FontWeight','bold','FontSize',30,'BackgroundColor','white');





%%



% Old version

% 
% clf
% ax1 = axes('position',[0.1 0.12 0.8 0.85],'box','on');
% ax2 = axes('position',[0.57 0.2 0.3 0.3],'box','on');
% axes(ax1);
% hold on
% plot(B/B1,EHofst/e,'.','MarkerSize',3,'Color',[0.38 0.38 0.38]);
% plot(B_lines/B1,ED_lines_mat/e,'Color','green','LineWidth',1);
% plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',15,'Color','red');
% plot([0 3],[0.116 0.116],'--','Color',[0.49 0.18 0.55],'LineWidth',2);
% plot(B_lines/B1,Efb_lines_mat/e,'Color','magenta');
% 
% text(0.07,0.1225,'E_F','FontSize',16,'Color',[0.49 0.18 0.55]);
% %x1 = 0.3 ;  % Section of Data to be zoomed into in inset
% %x2 = 0.52; % Those are the values for a nice looking plot
% %y1 = 0.08;
% %y2 = 0.11;
% x1 = 0.18 ;  % Section of Data to be zoomed into in inset
% x2 = 0.35;  % Here we try different sections of the data
% y1 = 0.05;
% y2 = 0.085;
% 
% %rectangle('Position',[x1 y1 x2-x1 y2-y1],'EdgeColor',[0.0 0.8 0.0],'LineWidth',1);
% rectangle('Position',[x1 y1 x2-x1 y2-y1],'EdgeColor','blue','LineWidth',1);
% 
% hold off
% xlim([0 3]);
% ylim([-0.005 0.226]);
% xlabel('\Phi/\Phi_0');
% ylabel('E (eV)');
% ax1.FontSize = 20;
% ax1.LineWidth = 1.5;
% 
% axes(ax2);
% %plot(B/B1,EHofst/e,'.','MarkerSize',2,'Color','blue');
% plot(B/B1,EHofst/e,'.','MarkerSize',2);
% 
% hold on
% plot(fb_mat/B1,fben_mat/e,'o','MarkerSize',15,'Color','red');
% %plot(B_lines/B1,Efb_lines_mat/e,'Color','magenta');
% 
% hold off
% xlim([x1 x2]);
% ylim([y1 y2]);
% %xlabel('\Phi/\Phi_0');
% %ylabel('E (eV)');
% ax2.FontSize = 16;
% ax2.LineWidth = 1.2;