function intervals = HofstadterLine(alpha,max_denom)
% this function generates one linecut of the Hofstadter butterfly at a
% given flux ratio alpha, which is taken to be rational, p/q = alpha.
% we might also want to round off to a maximum q, if desired.

% it returns a qx2 array intevals


%[p,q] = rat(alpha);

[p,q]=rat(round(alpha*max_denom)/max_denom); % keep denominator below max_denom
if q>max_denom
    "This can't happen"
end



nu = pi/(2*q); % this is the correct value


%nu = 1/(2*q);  % this seems to be wrong (in Hofstadter's paper)
%nu = 0;

poly = 0;

poly_lo = [1 -2*cos(2*pi*alpha*(1-1) - nu)];
poly_ro = -1;
poly_lu = 1;
poly_ru = 0;

for i = 2:q
%pause
%i
%poly_lo
%poly_ro
%poly_lu


polynew_lo = 0;
polynew_ro = 0;
polynew_lu = 0;
polynew_ru = 0;
    
poly_lu(2:i) = poly_lu;
poly_lu(1) = 0;
polynew_lo(2:i+1) = -2*cos(2*pi*(i-1)*alpha - nu)*poly_lo  - poly_lu;
polynew_lo(1:i) = polynew_lo(1:i) + poly_lo;

polynew_lu = poly_lo;


polynew_ro(2:i) = -2*cos(2*pi*(i-1)*alpha - nu)*poly_ro - poly_ru;
polynew_ro(1:i-1) = polynew_ro(1:i-1) + poly_ro;

%erhhe Grad des polynoms

polynew_ru(2:i) = poly_ro;
polynew_ru(1) = 0; % just in case

%pause





poly_lo = polynew_lo;

poly_lu = polynew_lu;

poly_ro = polynew_ro;

poly_ru = polynew_ru;

end



% Form trace
poly_ru(2:q+1)=poly_ru;
poly_ru(1) = 0;
poly = poly_lo + poly_ru;

% Force polynom to be symmetric: set all elements to zero starting from 2nd
% in steps of 2

%poly
poly(2:2:end)=0;
%poly



poly(q+1)=poly(q+1)-4;
ser4 = sort(real(roots(poly)));
poly(q+1)=poly(q+1)+8;
ser_minus4 = sort(real(roots(poly)));
poly(q+1)=poly(q+1)-4;
%yvals=0;
%yvals(1:q) = p/q;
%plot(ser4,yvals,'*');
%plot(ser_minus4,yvals,'*');



%pause
intervals = 0;
intervals(1:q,1:2)=0; % find start and end points of intervals

    for i = 1:q  % there are q roots
        intervals(i,1) = min(ser4(i),ser_minus4(i));
        intervals(i,2) = max(ser4(i),ser_minus4(i));
    end





end